$!++
$! compile sources in the [.VMS] subdirectory -- 27-OCT-1996 Uwe Zessin
$! The resulting .EXE is for the DCL environment.
$! Unsupported components are listed, but disabled via comment.
$!
$! 02-AUG-1997 ZE. -- rewrite to allow compilation of a single module
$!		 (pass via P1)
$! 29-NOV-1997 ZE. -- update for Python V1.5B1
$! 18-DEC-1997 ZE. -- implement P2
$!
$! P1 = modulename or "" (all modules including new .OLB)
$! P2 = "L" means: call LINKD_PY.COM after successful compile
$!	"LP" means: call LINKP_PY.COM after successful compile
$!	(some POSIX components are compiled with DCC.COM !)
$!--
$ write SYS$OUTPUT F$FAO("!79*-")
$ _SRC = P1
$ _DEFAULT = F$ENVIRONMENT("DEFAULT")
$ on ERROR then $ goto PROC_EXIT
$!
$ _PROCEDURE = F$ENVIRONMENT("PROCEDURE")
$ _DEVICE    = F$PARSE(_PROCEDURE,,,"DEVICE")
$ _DIRECTORY = F$PARSE(_PROCEDURE,,,"DIRECTORY")
$!
$ set DEFAULT '_DEVICE''_DIRECTORY'	! [.VMS]
$!
$ if (F$GETSYI("HW_MODEL").ge.1024)
$ then
$   _ARCH = "ALPHA"
$ else
$   _ARCH = "VAX"
$ endif
$ _OBJDIR = "[-.VMS.O_''_ARCH'.VMS]"
$ _OLBDIR = "[-.VMS.O_''_ARCH']"
$ _OLBFIL = _OLBDIR + "VMS.OLB"
$!
$ if (_SRC .eqs. "")
$ then
$   library /create /log '_OLBFIL'
$ else
$   _SRC = F$PARSE(_SRC,,,"NAME")	! extract module name
$   if (_SRC .nes. "")
$   then
$	call CC_LIBR '_SRC'
$	goto PROC_EXIT		! module compiled, done
$   endif
$ endif
$!
$   call CC_LIBR PYVMS_GLOBAL
$   call CC_LIBR PYVMS_INIT
$   call CC_LIBR PYVMS_READLINE
$   call CC_LIBR PYVMSMODULE
$!!   call CC_LIBR VMSDEF		! vmsdef module
$   call CC_LIBR VMS_LBR
$   call CC_LIBR VMS_LIB
$   call CC_LIBR VMS_SYS
$!@@--   call CC_LIBR VMS_DEFTABLE
$!@@--   call CC_LIBR VMS_DVI_TRNTBL
$!@@--   call CC_LIBR VMS_DVIDEF
$!@@--   call CC_LIBR VMS_JPI_TRNTBL
$   call CC_LIBR VMS_JPIDEF
$   call CC_LIBR VMS_KGBDEF
$   call CC_LIBR VMS_LNMDEF
$!@@--   call CC_LIBR VMS_QUI_TRNTBL
$   call CC_LIBR VMS_QUIDEF
$!@@--   call CC_LIBR VMS_SYI_TRNTBL
$!@@--   call CC_LIBR VMS_SYIDEF
$   call CC_LIBR VMS__CVT
$   call CC_LIBR VMS__CVT_PYLONG
$   call CC_LIBR VMS__IOCTL
$   call CC_LIBR VMS__GETBUILDINFO ! replaces [-.MODULES]GETBUILDINFO.C
$   call CC_LIBR VMS__GETCOPYRIGHT ! replaces [-.PYTHON]GETCOPYRIGHT.C
$   call CC_LIBR VMS__GETPATH      ! replaces [-.MODULES]GETPATH.C
$   call CC_LIBR VMS__GETTIMEOFDAY
$   call CC_LIBR VMS__GMTIME
$   call CC_LIBR VMS__READDIR
$   call CC_LIBR VMS__RMDIR
$   call CC_LIBR VMS__TIMES
$   call CC_LIBR VMS__UTIME
$!  call CC_LIBR VMSIO
$   call CC_LIBR VMSMISC
$!!   call CC_LIBR VMSMODULE
$   call CC_LIBR POSIXMODULE
$   call CC_LIBR CONFIG         ! not in .OLB, on LINK command line
$!
$!!   call CC_LIBR MAIN           ! 'main' program entry
$!
$PROC_EXIT:
$ set DEFAULT '_DEFAULT'
$! -----
$ P2 = F$EDIT(P2,"COLLAPSE,UPCASE")
$ if (P2 .nes. "")
$ then
$   if (P2 .eqs. "L")
$   then
$     write SYS$OUTPUT "%DCC_VMS-I-STARTLNK, starting LINK"
$     @LINKD_PY
$   else
$     if (P2 .eqs. "LP")
$     then
$	write SYS$OUTPUT "%DCC_VMS-I-STARTLNK, starting LINK (POSIX)"
$	@LINKP_PY
$     else
$	write SYS$OUTPUT "%DCC_VMS-E-BADPARAM, bad parameter P2 - ignored"
$	write SYS$OUTPUT " \", P2, "\"
$     endif
$   endif
$ endif
$! -----
$ exit
$! ----------------------------------------
$CC_LIBR: SUBROUTINE
$!+
$! - P1 = module name
$!-
$! -- don't put these modules into the object library
$ if (P1 .eqs. "CONFIG") .or. (P1 .eqs. "MAIN")
$ then
$   _OLBFIL = ""
$ endif
$!
$ @[-.VMS]DCC 'P1' '_OBJDIR' '_OLBFIL'
$!
$ ENDSUBROUTINE ! CC_LIBR: 
