$ _D = 0
$ close/nolog FIL_INP
$ close/nolog FIL_OUT
$ close/nolog FIL_TMPCBT ! constant/bitmask table
$ close/nolog FIL_TMPTXT
$!
$ T_VERSION = ""
$ T_TITLE  = ""
$ X_ITMLST_DEFINITION  = "TRUE"
$ X_ITMLST_1ST_ELEMENT = "TRUE"
$ X_BITMSK_DEFINITION  = "FALSE"
$ X_BITMSK_1ST_MASK    = "TRUE"
$ X_CONST_DEFINITION   = "FALSE"
$ X_CONST_1ST_VALUE    = "TRUE"
$!
$ if (P1 .eqs. "")
$ then
$   write SYS$ERROR "%VMSDEF2MAR-F-BADP1, parameter 1 - VMSDEF_xxx.DAT file"
$   exit %X2C
$ endif
$ T_NAM = F$PARSE(P1,,,"NAME")
$ T_FIL_INP = T_NAM+ ".DAT"
$ T_FIL_OUT = T_NAM+ ".MAR"
$!
$ _ALQ = F$FILE_ATTRIBUTES(T_FIL_INP,"ALQ")	! pre-allocate files
$ _ALQ_OUT = _ALQ * 3
$ _ALQ_TMPTXT = _ALQ * 3 / 2
$!
$ open/read  FIL_INP 'T_FIL_INP' ! 'P1'
$ copy /nolog _NLA0: /ALLOCATION='_ALQ_OUT' 'T_FIL_OUT'
$ open/append FIL_OUT 'T_FIL_OUT'
$ write FIL_OUT "; FIL=",T_FIL_INP, ", CDT=", F$FILE_ATTRIBUTES(T_FIL_INP,"CDT")
$ write FIL_OUT "; NOW=",F$TIME(),-
		" USR=",F$EDIT(F$GETJPI(0,"USERNAME"),"COLLAPSE")
$ write FIL_OUT ";"
$!
$ T_ASCIZ_TMPTXT = "SYS$SCRATCH:VMSDEF2MAR_ASCIZ_''F$GETJPI(0,"PID")'.TMP"
$ copy /nolog _NLA0: /ALLOCATION='_ALQ_TMPTXT' 'T_ASCIZ_TMPTXT'
$ open/append FIL_TMPTXT 'T_ASCIZ_TMPTXT'	! text strings
$!
$ T_ASCIZ_TMPCBT = "SYS$SCRATCH:VMSDEF2MAR_CBTMP_''F$GETJPI(0,"PID")'.TMP"
$ copy /nolog _NLA0: /ALLOCATION=20 'T_ASCIZ_TMPCBT'
$ open/append FIL_TMPCBT 'T_ASCIZ_TMPCBT'	! constant/bitmask table
$!
$ write SYS$ERROR "%VMSDEF2MAR-I-TRANSMOD, translating module: ", T_NAM
$!
$ TAB[0,8]=9
$ L_ADDRESS_COUNT = 1
$LOOP_ITMLST:
$ read /END_OF_FILE=EOF FIL_INP T_RECORD
$ if _D then $ show symbol T_RECORD
$ if (F$EDIT(T_RECORD,"COLLAPSE") .eqs. "")
$ then
$   goto LOOP_ITMLST				! skip empty line
$ endif
$ if (F$EXTRACT(0,1,T_RECORD) .eqs. "=")
$ then
$   gosub EQ_LINE
$   goto LOOP_ITMLST
$ endif
$ if (F$EXTRACT(0,1,T_RECORD) .eqs. "!")
$ then
$   goto LOOP_ITMLST					! ignore comment
$ endif
$ if (X_ITMLST_DEFINITION)
$ then
$   if (X_ITMLST_1ST_ELEMENT)
$   then
$     X_ITMLST_1ST_ELEMENT = "FALSE"
$     if (T_TITLE .eqs. "")
$     then
$	write SYS$ERROR "%VMSDEF2MAR-F-NOTITLE, missing or misplaced =TITLE="
$	close/nolog FIL_INP
$	close/nolog FIL_OUT
$	close/nolog FIL_TMPTXT
$	close/nolog FIL_TMPCBT
$	exit %X2C
$     endif
$     T_MODULE = F$EDIT(F$ELEMENT(0," ",T_TITLE),"COLLAPSE")
$     if (T_MODULE .eqs. "")
$     then
$	write SYS$ERROR "%VMSDEF2MAR-F-NOMODULE, format error for =TITLE="
$	write SYS$ERROR " \use: =TITLE=module<SPACE>description\"
$	close/nolog FIL_INP
$	close/nolog FIL_OUT
$	close/nolog FIL_TMPTXT
$	close/nolog FIL_TMPCBT
$	exit %X2C
$     endif
$     write FIL_OUT ";"
$     write FIL_OUT TAB,".NTYPE ...ON_ALPHA...,R31"
$     write FIL_OUT TAB,".IIF EQ,<...ON_ALPHA...@-4&^XF>-5, ALPHA=0"
$     write FIL_OUT TAB,".IIF DF,ALPHA,  .DISABLE FLAGGING"
$     write FIL_OUT ";"
$     write FIL_OUT TAB,".psect VMSDEF_DATA PIC,SHR,NOEXE,RD,NOWRT"
$     write FIL_OUT ";"
$     T_MODULE = T_MODULE - "VMSDEF_"
$     write FIL_OUT    "VMSDEF_GR_", T_MODULE, "::"	! start item code table
$     write FIL_TMPCBT "VMSDEF_GR_CB_", T_MODULE, "::"	! start const/bitmask "
$     !
$     ! @@ add to list of modules ...
$   endif
$   !
$   T_RECORD = F$EDIT(T_RECORD,"UPCASE,COMPRESS")
$   T_ITM_NAM   = F$ELEMENT(0," ",T_RECORD)
$   T_ITM_COD   = F$ELEMENT(1," ",T_RECORD)
$   W_MINVMSVER = F$ELEMENT(2," ",T_RECORD)
$   if (F$LOCATE("/",W_MINVMSVER) .nes. F$LENGTH(W_MINVMSVER))
$   then
$     ! maximum VMS version number explicit specified
$     W_MAXVMSVER = F$ELEMENT(1,"/",W_MINVMSVER)
$     W_MINVMSVER = F$ELEMENT(0,"/",W_MINVMSVER)
$   else
$     ! set a default maximum VMS version number 
$     W_MAXVMSVER = "32767" ! not sure if all compares are using unsigned
$   endif
$   if (W_MAXVMSVER .lt. W_MINVMSVER)
$   then
$     write SYS$ERROR "%VMSDEF2MAR-E-BADVER, maxversion(",W_MAXVMSVER,")>minversion(",W_MINVMSVER,")"
$     write SYS$ERROR " \item=", T_ITM_NAM, "\"
$   endif
$   T_ARCH      = F$ELEMENT(3," ",T_RECORD)
$     X_ARCH_VAX   = (F$EXTRACT(0,1,T_ARCH) .eqs. "V")
$     X_ARCH_ALPHA = (F$EXTRACT(1,1,T_ARCH) .eqs. "A")
$   T_PARVAL    = F$ELEMENT(4," ",T_RECORD)
$   W_BUFSIZ    = F$ELEMENT(5," ",T_RECORD)
$   T_VARTYP    = F$ELEMENT(6," ",T_RECORD)
$     T_VARTYP_LIB = F$ELEMENT(0,"/",T_VARTYP)
$     T_VARTYP_SYS = F$ELEMENT(1,"/",T_VARTYP)
$   L_BITMSKPTR = F$ELEMENT(7," ",T_RECORD)
$   !
$   L_FLAGS = 0	! /* synchronize names + values with VMSDEF.H ! */
$   T_FLAGS = ""
$   ITMTBL_M_ARCH_VAX      =  1
$   ITMTBL_M_ARCH_ALPHA    =  2
$   ITMTBL_M_GETSYI_SYSPAR =  4	! same bit, different call
$   ITMTBL_M_GETQUI_FNCREQ =  4	! request function code
$   ITMTBL_M_GETSYI_SYSVAL =  8
$   ITMTBL_M_ITMOUT	   =  8	! output item code
$   ITMTBL_M_ITMINP	   = 16 ! input item code
$   if (X_ARCH_VAX)
$   then
$     L_FLAGS = L_FLAGS .or. ITMTBL_M_ARCH_VAX
$     if (T_FLAGS .nes. "")
$     then
$	T_FLAGS = T_FLAGS + "+"
$     endif
$     T_FLAGS = T_FLAGS + "ITMTBL_M_ARCH_VAX"
$   endif
$   if (X_ARCH_ALPHA)
$   then
$     L_FLAGS = L_FLAGS .or. ITMTBL_M_ARCH_ALPHA
$     if (T_FLAGS .nes. "")
$     then
$	T_FLAGS = T_FLAGS + "+"
$     endif
$     T_FLAGS = T_FLAGS + "ITMTBL_M_ARCH_ALPHA"
$   endif
$   !
$   ! $GETSYI()
$   if (T_PARVAL .eqs. "P")
$   then
$     L_FLAGS = L_FLAGS .or. ITMTBL_M_GETSYI_SYSPAR
$     if (T_FLAGS .nes. "")
$     then
$	T_FLAGS = T_FLAGS + "+"
$     endif
$     T_FLAGS = T_FLAGS + "ITMTBL_M_GETSYI_SYSPAR"
$   endif
$   if (T_PARVAL .eqs. "V")
$   then
$     L_FLAGS = L_FLAGS .or. ITMTBL_M_GETSYI_SYSVAL
$     if (T_FLAGS .nes. "")
$     then
$	T_FLAGS = T_FLAGS + "+"
$     endif
$     T_FLAGS = T_FLAGS + "ITMTBL_M_GETSYI_SYSVAL"
$   endif
$   !
$   ! $GETQUI()
$   if (T_PARVAL .eqs. "R")
$   then
$     L_FLAGS = L_FLAGS .or. ITMTBL_M_GETQUI_FNCREQ
$     if (T_FLAGS .nes. "")
$     then
$	T_FLAGS = T_FLAGS + "+"
$     endif
$     T_FLAGS = T_FLAGS + "ITMTBL_M_GETQUI_FNCREQ"
$   endif
$   ! input item
$   if (F$LOCATE("I",T_PARVAL) .ne. F$LENGTH(T_PARVAL))
$   then
$     L_FLAGS = L_FLAGS .or. ITMTBL_M_ITMINP
$     if (T_FLAGS .nes. "")
$     then
$	T_FLAGS = T_FLAGS + "+"
$     endif
$     T_FLAGS = T_FLAGS + "ITMTBL_M_ITMINP"
$   endif
$   ! output item
$   if (F$LOCATE("O",T_PARVAL) .ne. F$LENGTH(T_PARVAL))
$   then
$     L_FLAGS = L_FLAGS .or. ITMTBL_M_ITMOUT
$     if (T_FLAGS .nes. "")
$     then
$	T_FLAGS = T_FLAGS + "+"
$     endif
$     T_FLAGS = T_FLAGS + "ITMTBL_M_ITMOUT"
$   endif
$   !
$   if (X_ARCH_ALPHA .and. (.not. X_ARCH_VAX))
$   then
$     write FIL_OUT    TAB,".if DF ALPHA"
$     write FIL_TMPTXT TAB,".if DF ALPHA"
$   endif
$   if ((.not. X_ARCH_ALPHA) .and. X_ARCH_VAX)
$   then
$     write FIL_OUT    TAB,".if NDF ALPHA"
$     write FIL_TMPTXT TAB,".if NDF ALPHA"
$   endif
$   write FIL_TMPTXT "VMSDEF_T_", T_MODULE, "__''L_ADDRESS_COUNT':''TAB'.asciz '",T_ITM_NAM ,"'"
$   write FIL_OUT TAB,".word	 ", T_ITM_COD, TAB, "; ", T_ITM_NAM	! w_itmcod
$   write FIL_OUT TAB,".word	 ", W_MINVMSVER				! w_vmsvermin
$   write FIL_OUT TAB,".word	 ", W_MAXVMSVER				! w_vmsvermax
$   write FIL_OUT TAB,".word	 0"					! w_filler
$   write FIL_OUT TAB,".address VMSDEF_T_", T_MODULE, "__''L_ADDRESS_COUNT'" ! at_itmnam_py
$   if (L_BITMSKPTR .eqs. "0")
$   then
$     ! no pointer, indicated by 0
$     write FIL_OUT TAB,".long	 ", L_BITMSKPTR				! ar_bitmsk
$   else
$     ! pointer to structure describing the bits
$     write FIL_OUT TAB,".address ", L_BITMSKPTR			! ar_bitmsk
$   endif
$   write FIL_OUT TAB,".long	 ", L_FLAGS				! l_flags
$   write FIL_OUT TAB,".word	 ", W_BUFSIZ				! w_bufsiz
$   write FIL_OUT TAB,".byte	 ^A'", T_VARTYP_LIB ,"'"		! c_typ_lib
$   write FIL_OUT TAB,".byte	 ^A'", T_VARTYP_SYS ,"'"		! c_typ_sys
$   if (X_ARCH_ALPHA .and. (.not. X_ARCH_VAX))
$   then
$     write FIL_OUT    TAB,".ENDC;DF ALPHA"
$     write FIL_TMPTXT TAB,".ENDC;DF ALPHA"
$   endif
$   if ((.not. X_ARCH_ALPHA) .and. X_ARCH_VAX)
$   then
$     write FIL_OUT    TAB,".ENDC;NDF ALPHA"
$     write FIL_TMPTXT TAB,".ENDC;NDF ALPHA"
$   endif
$   !
$   L_ADDRESS_COUNT = L_ADDRESS_COUNT + 1
$ else ! if (X_ITMLST_DEFINITION)
$   if (X_BITMSK_DEFINITION)
$   then
$     ! bitmask definition
$     T_RECORD = F$EDIT(T_RECORD,"UPCASE,COMPRESS")
$     T_BIT_NAM   = F$ELEMENT(0," ",T_RECORD)
$     L_BIT_MSK   = F$ELEMENT(1," ",T_RECORD)
$     W_MINVMSVER = F$ELEMENT(2," ",T_RECORD)
$     if (F$LOCATE("/",W_MINVMSVER) .nes. F$LENGTH(W_MINVMSVER))
$     then
$	! maximum VMS version number explicit specified
$	W_MAXVMSVER = F$ELEMENT(1,"/",W_MINVMSVER)
$	W_MINVMSVER = F$ELEMENT(0,"/",W_MINVMSVER)
$     else
$	! set a default maximum VMS version number 
$	W_MAXVMSVER = "32767" ! not sure if all compares are using unsigned
$     endif
$     if (W_MAXVMSVER .lt. W_MINVMSVER)
$     then
$	write SYS$ERROR "%VMSDEF2MAR-E-BADVER, maxversion(",W_MAXVMSVER,")>minversion(",W_MINVMSVER,")"
$	write SYS$ERROR " \item=", T_BIT_NAM, "\"
$     endif
$     T_ARCH      = F$ELEMENT(3," ",T_RECORD)
$	X_ARCH_VAX   = (F$EXTRACT(0,1,T_ARCH) .eqs. "V")
$	X_ARCH_ALPHA = (F$EXTRACT(1,1,T_ARCH) .eqs. "A")
$     T_MSKSIZ    = F$ELEMENT(4," ",T_RECORD) ! 'L' = 32-bit
$     !					    ! @@ currently no support for 64bit
$     !
$     write FIL_TMPTXT "VMSDEF_T_", T_MODULE, "__''L_ADDRESS_COUNT':''TAB'.asciz '",T_BIT_NAM ,"'"
$     write FIL_OUT TAB,".long	 ", L_BIT_MSK, TAB, "; ", T_BIT_NAM		! l_bit_value
$     write FIL_OUT TAB,".address VMSDEF_T_", T_MODULE, "__''L_ADDRESS_COUNT'"	! at_bit_name
$     write FIL_OUT TAB,".word	 ", W_MINVMSVER					! w_vmsvermin
$     write FIL_OUT TAB,".word	 ", W_MAXVMSVER					! w_vmsvermax
$     !
$     L_ADDRESS_COUNT = L_ADDRESS_COUNT + 1
$   else ! if (X_BITMSK_DEFINITION)
$     if (X_CONST_DEFINITION)
$     then
$	! constant definition
$	T_RECORD = F$EDIT(T_RECORD,"UPCASE,COMPRESS")
$	T_CON_NAM   = F$ELEMENT(0," ",T_RECORD)
$	L_CON_VAL   = F$ELEMENT(1," ",T_RECORD)
$	W_MINVMSVER = F$ELEMENT(2," ",T_RECORD)
$	if (F$LOCATE("/",W_MINVMSVER) .nes. F$LENGTH(W_MINVMSVER))
$	then
$	  ! maximum VMS version number explicit specified
$	  W_MAXVMSVER = F$ELEMENT(1,"/",W_MINVMSVER)
$	  W_MINVMSVER = F$ELEMENT(0,"/",W_MINVMSVER)
$	else
$	  ! set a default maximum VMS version number 
$	  W_MAXVMSVER = "32767" ! not sure if all compares are using unsigned
$	endif
$	if (W_MAXVMSVER .lt. W_MINVMSVER)
$	then
$	  write SYS$ERROR "%VMSDEF2MAR-E-BADVER, maxversion(",W_MAXVMSVER,")>minversion(",W_MINVMSVER,")"
$	  write SYS$ERROR " \item=", T_CON_NAM, "\"
$	endif
$	T_ARCH      = F$ELEMENT(3," ",T_RECORD)
$	  X_ARCH_VAX   = (F$EXTRACT(0,1,T_ARCH) .eqs. "V")
$	  X_ARCH_ALPHA = (F$EXTRACT(1,1,T_ARCH) .eqs. "A")
$	T_VALSIZ    = F$ELEMENT(4," ",T_RECORD) ! 'L' = 32-bit
$	!				    ! @@ currently no support for 64bit
$	!
$	write FIL_TMPTXT "VMSDEF_T_", T_MODULE, "__''L_ADDRESS_COUNT':''TAB'.asciz '",T_CON_NAM ,"'"
$	write FIL_OUT TAB,".long	 ", L_CON_VAL, TAB, "; ", T_CON_NAM
$	write FIL_OUT TAB,".address VMSDEF_T_", T_MODULE, "__''L_ADDRESS_COUNT'"
$	write FIL_OUT TAB,".word	 ", W_MINVMSVER
$	write FIL_OUT TAB,".word	 ", W_MAXVMSVER
$	!
$	L_ADDRESS_COUNT = L_ADDRESS_COUNT + 1
$     else ! if (X_CONST_DEFINITION)
$	write SYS$ERROR "%VMSDEF2MAR-F-BUGCHK1, program went into bad state"
$	write SYS$ERROR "  neither ITEMLIST nor BITMASK32 nor CONSTANT32"
$	write SYS$ERROR "  rerun program with $ SET VERIFY for debug"
$	close/nolog FIL_INP
$	close/nolog FIL_OUT
$	close/nolog FIL_TMPTXT
$	close/nolog FIL_TMPCBT
$	exit %X2C
$     endif ! if (X_CONST_DEFINITION)
$   endif ! if (X_BITMSK_DEFINITION)
$ endif ! if (X_ITMLST_DEFINITION)
$ goto LOOP_ITMLST
$!
$EOF:
$ if (X_ITMLST_DEFINITION)
$ then
$   ! still in item-list definition - terminate list
$   call TERMINATE_LIST "ITEM"
$ else
$   ! @@ (BITMASK + CONSTANT currently share the same structure but this
$   !     can change)
$   if (X_BITMSK_DEFINITION)
$   then
$     ! terminate last bitmask
$     call TERMINATE_LIST "BITMASK"
$   else
$     if (X_CONST_DEFINITION)
$     then
$	! terminate last constant
$	call TERMINATE_LIST "CONSTANT"
$     else
$	write SYS$ERROR "%VMSDEF2MAR-F-BUGCHK2, program went into bad state"
$	write SYS$ERROR "  neither ITEMLIST nor BITMASK32 nor CONSTANT32"
$	write SYS$ERROR "  rerun program with $ SET VERIFY for debug"
$	close/nolog FIL_INP
$	close/nolog FIL_OUT
$	close/nolog FIL_TMPTXT
$	close/nolog FIL_TMPCBT
$	exit %X2C
$     endif
$   endif
$ endif
$!
$ close/nolog FIL_INP
$ close/nolog FIL_OUT
$ close/nolog FIL_TMPTXT
$!
$ write FIL_TMPCBT TAB,".long",TAB,"0",TAB,"; terminate const/bitmsk table
$ write FIL_TMPCBT TAB,".long",TAB,"0"
$ write FIL_TMPCBT ";"
$ close/nolog FIL_TMPCBT
$!
$ append 'T_ASCIZ_TMPCBT' 'T_FIL_OUT'
$ delete 'T_ASCIZ_TMPCBT';*
$!
$ append 'T_ASCIZ_TMPTXT' 'T_FIL_OUT'
$ delete 'T_ASCIZ_TMPTXT';*
$!
$ open/append FIL_OUT 'T_FIL_OUT'
$ write FIL_OUT ";"
$ write FIL_OUT TAB,".end"
$ close/nolog FIL_OUT
$!
$ exit
$! ----------------------------------------------------------------------------
$EQ_LINE:
$ if (F$EXTRACT(0,11,T_RECORD) .eqs. "=BITMASK32=")
$ then
$   if (X_ITMLST_DEFINITION)
$   then
$     ! terminate item-list
$     call TERMINATE_LIST "ITEM"
$   else
$     ! @@ (BITMASK + CONSTANT currently share the same structure but this
$     !     can change)
$     if (X_CONST_DEFINITION)
$     then
$	! terminate preceeding constant
$	call TERMINATE_LIST "CONSTANT"
$     else
$	if (.not. X_BITMSK_1ST_MASK)
$	then
$	  ! terminate preceeding bitmask
$	  call TERMINATE_LIST "BITMASK"
$	endif
$     endif
$   endif
$   _LABEL = F$EXTRACT(11,999,T_RECORD)
$   write FIL_OUT _LABEL, ":"
$   write FIL_TMPCBT TAB,".address ",_LABEL
$   write FIL_TMPCBT TAB,".long",TAB, "1"	! CONMSKTBL_K_BITMASK32
$   X_ITMLST_DEFINITION = "FALSE"
$   X_BITMSK_DEFINITION = "TRUE"
$   X_BITMSK_1ST_MASK   = "FALSE"
$   X_CONST_DEFINITION  = "FALSE"
$   X_CONST_1ST_VALUE   = "TRUE"
$   goto EQ_LINE_EXIT
$ endif
$!
$ if (F$EXTRACT(0,12,T_RECORD) .eqs. "=CONSTANT32=")
$ then
$   if (X_ITMLST_DEFINITION)
$   then
$     ! terminate item-list
$     call TERMINATE_LIST "ITEM"
$   else
$     ! @@ (BITMASK + CONSTANT currently share the same structure but this
$     !     can change)
$     if (X_BITMSK_DEFINITION)
$     then
$	! terminate preceeding bitmask
$	call TERMINATE_LIST "BITMASK"
$     else
$	if (.not. X_CONST_1ST_VALUE)
$	then
$	  ! terminate preceeding bitmask/constant
$	  call TERMINATE_LIST "CONSTANT"
$	endif
$     endif
$   endif
$   _LABEL = F$EXTRACT(12,999,T_RECORD)
$   write FIL_OUT _LABEL, ":"
$   write FIL_TMPCBT TAB,".address ",_LABEL
$   write FIL_TMPCBT TAB,".long",TAB, "2"	! CONMSKTBL_K_CONSTANT32
$   X_ITMLST_DEFINITION = "FALSE"
$   X_BITMSK_DEFINITION = "FALSE"
$   X_BITMSK_1ST_MASK   = "TRUE"
$   X_CONST_DEFINITION  = "TRUE"
$   X_CONST_1ST_VALUE   = "FALSE"
$   goto EQ_LINE_EXIT
$ endif
$!
$ if (F$EXTRACT(0,9,T_RECORD) .eqs. "=LIBRARY=")
$ then
$   T_LIBRARY = F$EXTRACT(9,9999,T_RECORD)
$   write FIL_OUT TAB,".library '", T_LIBRARY, "'"
$   goto EQ_LINE_EXIT
$ endif
$!
$ if (F$EXTRACT(0,6,T_RECORD) .eqs. "=LINE=")
$ then
$   T_LINE = F$EXTRACT(6,9999,T_RECORD)
$   write FIL_OUT TAB, T_LINE
$   goto EQ_LINE_EXIT
$ endif
$!
$ if (F$EXTRACT(0,7,T_RECORD) .eqs. "=TITLE=")
$ then
$   if (T_TITLE .eqs. "")
$   then
$     T_TITLE = F$EXTRACT(7,9999,T_RECORD)
$     write FIL_OUT TAB,".title ", T_TITLE
$     goto EQ_LINE_EXIT
$   else
$     write SYS$ERROR "%VMSDEF2MAR-W-DUPKEY, duplicate =TITLE= line - ignored"
$     write SYS$ERROR " \",T_RECORD,"\"
$   endif
$ endif
$!
$ if (F$EXTRACT(0,9,T_RECORD) .eqs. "=VERSION=")
$ then
$   if (T_VERSION .eqs. "")
$   then
$     T_VERSION = F$EXTRACT(9,9999,T_RECORD)
$     write FIL_OUT TAB,".ident '", T_VERSION, "'"
$     goto EQ_LINE_EXIT
$   else
$     write SYS$ERROR "%VMSDEF2MAR-W-DUPKEY, duplicate =VERSION= line - ignored"
$     write SYS$ERROR " \",T_RECORD,"\"
$   endif
$ endif
$!
$ write SYS$ERROR "%VMSDEF2MAR-E-BADEQLIN, bad '=' line - skipping until next ="
$ write SYS$ERROR " \",T_RECORD,"\"
$LOOP_NEXT_EQ:
$ read /END_OF_FILE=EQ_LINE_EXIT FIL_INP T_RECORD
$ if _D then $ show symbol T_RECORD
$ if (F$EXTRACT(0,1,T_RECORD) .eqs. "=")
$ then
$   goto EQ_LINE
$ endif
$ goto LOOP_NEXT_EQ
$!
$EQ_LINE_EXIT:
$ return ! procedure $EQ_LINE: 
$! ----------------------------------------------------------------------------
$TERMINATE_LIST: SUBROUTINE
$ if (P1 .eqs. "ITEM")
$ then
$   ! terminate item-list
$   write FIL_OUT ";"
$   write FIL_OUT TAB,".word	 0"
$   write FIL_OUT TAB,".word	 0	; THIS 0 terminates the ITEM list"
$   write FIL_OUT ";"
$ else
$   ! @@ (BITMASK + CONSTANT currently share the same structure but this
$   !     can change)
$   if (P1 .eqs. "BITMASK")
$   then
$     ! terminate bitmask
$     write FIL_OUT ";"
$     write FIL_OUT TAB,".long	 0"
$     write FIL_OUT TAB,".long	 0"
$     write FIL_OUT TAB,".word	 0	; THIS 0 terminates the BITMASK list"
$     write FIL_OUT TAB,".word	 0"
$     write FIL_OUT ";"
$   else
$     if (P1 .eqs. "CONSTANT")
$     then
$	! terminate constant
$	write FIL_OUT ";"
$	write FIL_OUT TAB,".long	 0"
$	write FIL_OUT TAB,".long	 0"
$	write FIL_OUT TAB,".word	 0	; THIS 0 terminates the CONSTANT list"
$	write FIL_OUT TAB,".word	 0"
$	write FIL_OUT ";"
$     else
$	write SYS$ERROR "%VMSDEF2MAR-F-BUGCHK3, program went into bad state"
$	write SYS$ERROR "  neither ITEMLIST nor BITMASK32 nor CONSTANT32"
$	write SYS$ERROR "  rerun program with $ SET VERIFY for debug"
$	close/nolog FIL_INP
$	close/nolog FIL_OUT
$	close/nolog FIL_TMPTXT
$	close/nolog FIL_TMPCBT
$	exit %X2C
$     endif
$   endif
$ endif
$ exit 1
$ ENDSUBROUTINE
