$!++
$! compile sources in the [.VMS] subdirectory -- 27-OCT-1996 Uwe Zessin
$! The resulting PYTHON_arch. is for the POSIX environment.
$! Unsupported/ unneeded components are listed, but disabled via comment.
$!
$! Note: some files are compiled via DCC.COM, not PCC !
$!
$! 23-AUG-1997 ZE. -- rewrite to allow compilation of a single module
$!		 (pass via P1)
$! 29-NOV-1997 ZE. -- update for Python V1.5B1
$!
$! P1 = modulename or "" (all modules including new .OLB)
$!--
$ _SRC = P1
$ _DEFAULT = F$ENVIRONMENT("DEFAULT")
$ on ERROR then $ goto PROC_EXIT
$!
$ _PROCEDURE = F$ENVIRONMENT("PROCEDURE")
$ _DEVICE    = F$PARSE(_PROCEDURE,,,"DEVICE")
$ _DIRECTORY = F$PARSE(_PROCEDURE,,,"DIRECTORY")
$!
$ set DEFAULT '_DEVICE''_DIRECTORY'	! [.VMS]
$!
$ if (F$GETSYI("HW_MODEL").ge.1024)
$ then
$   _ARCH = "ALPHA"
$ else
$   _ARCH = "VAX"
$ endif
$ _OBJDIR = "[-.VMS.O_''_ARCH'.VMS]"
$ _OLBDIR = "[-.VMS.O_''_ARCH']"
$ _OLBFIL = _OLBDIR + "VMS.A"
$!
$ if (_SRC .eqs. "")
$ then
$   library /create /log '_OLBFIL'
$ else
$   _SRC = F$PARSE(_SRC,,,"NAME")	! extract module name
$   if (_SRC .nes. "")
$   then
$	if (_SRC .eqs. "VMS__GETTIMEOFDAY")
$	then
$	  C_C = "CC_LIBR_D"
$	else
$	  C_C = "CC_LIBR_P"
$	endif
$	call 'C_C' '_SRC'
$	goto PROC_EXIT		! module compiled, done
$   endif
$ endif
$!
$ C_D = "call CC_LIBR_D"
$ C_P = "call CC_LIBR_P"
$!
$   C_D VMS__GETTIMEOFDAY	! use DCC, not PCC! (need <descrip.h>)
$!
$!-$   C_P VMS_LIB		! the following list has not been maintained!
$!-$   C_P VMS_SYS		!  - check with DCC_VMS.COM
$!-$   C_P VMS_DEFTABLE
$!-$   C_P VMS_DVI_TRNTBL
$!-$   C_P VMS_DVIDEF
$!-$   C_P VMS_JPI_TRNTBL
$!-$   C_P VMS_JPIDEF
$!-$   C_P VMS_KGBDEF
$!-$   C_P VMS_QUI_TRNTBL
$!-$   C_P VMS_QUIDEF
$!-$   C_P VMS_SYI_TRNTBL
$!-$   C_P VMS_SYIDEF
$!-$   C_P VMS__CVT
$      C_P VMS__GETBUILDINFO	! replaces [-.MODULES]GETBUILDINFO.C
$      C_P VMS__GETCOPYRIGHT	! replaces [-.PYTHON]GETCOPYRIGHT.C
$!-$!  C_P VMS__GMTIME		! VMS_POSIX has working gmtime()
$!-$!  C_P VMS__TIMES		! VMS_POSIX has a complete times()
$!-$   C_P VMSIO
$!-$   C_P VMSMISC
$!-$   C_P VMSMODULE
$!-$   C_P POSIXMODULE	! in [-.modules]posixmodule.c
$!
$   C_P CONFIG		! not in VMS.A, but on LINK command line
$!!   C_P MAIN		! 'main' program entry
$!
$!
$PROC_EXIT:
$ set DEFAULT '_DEFAULT'
$ exit
$! ----------------------------------------
$CC_LIBR_D: SUBROUTINE
$!+
$! - P1 = module name
$!-
$ _OBJDIR = _OBJDIR + ".O"	! must go into .A object library
$ @[-.VMS]DCC 'P1' '_OBJDIR' '_OLBFIL'
$!
$ ENDSUBROUTINE ! CC_LIBR: 
$! ----------------------------------------
$CC_LIBR_P: SUBROUTINE
$!+
$! - P1 = module name
$! - P2 = optional /DEFINE
$!-
$! -- don't put these modules into the object library
$ if ((P1 .eqs. "CONFIG") .or. (P1 .eqs. "MAIN"))
$ then
$   _OLBFIL = ""
$ endif
$!
$ @[-.VMS]PCC "''P1'" "''_OBJDIR'" "''_OLBFIL'" "''P2'"
$!
$ ENDSUBROUTINE ! CC_LIBR_P: 
$! ----------------------------------------
