$!+
$! build directory of VMSDEF tables
$!-
$!
$!
$ _D = 0
$ close/nolog FIL_INP
$ close/nolog FIL_OUT
$ close/nolog FIL_TMP
$!
$ T_TITLE  = ""
$ TAB[0,8] = 9
$!
$ T_FIL_OUT = "VMSDEF_DIRECTORY.MAR"
$ open/write FIL_OUT 'T_FIL_OUT'
$ T_NOW = F$TIME()
$ T_DATE = F$CVTIME(T_NOW,"COMPARISON","YEAR")  + -
	   F$CVTIME(T_NOW,"COMPARISON","MONTH") + -
	   F$CVTIME(T_NOW,"COMPARISON","DAY")   !!!
$ write FIL_OUT "; NOW=", T_NOW , -
		" USR=",F$EDIT(F$GETJPI(0,"USERNAME"),"COLLAPSE")
$ write FIL_OUT ";"
$ write FIL_OUT TAB,".title VMSDEF_DIRECTORY list of VMSDEF tables"
$ write FIL_OUT TAB,".ident '", T_DATE, "'"
$ write FIL_OUT ";"
$ write FIL_OUT "VMSDEF_GR_DIRECTORY::"
$ L_ADDRESS_COUNT = 1
$!
$ _F = F$SEARCH("@")	! delete old context
$LOOP_VMSDEF:
$ T_FIL = F$SEARCH("VMSDEF_*.DAT;")
$ if (T_FIL .eqs. "") then $ goto NO_MORE_VMSDEF
$ T_NAM = F$PARSE(T_FIL,,,"NAME")
$ T_FIL_INP = T_NAM+ ".DAT"
$!
$ open/read  FIL_INP 'T_FIL_INP' ! 'P1'
$ X_TITLE  = "FALSE"	! TRUE = title found, next file
$ T_ASCIZ_TMP = "SYS$SCRATCH:VMSDEF_BLDDIR_ASCIZ_''F$GETJPI(0,"PID")'.TMP"
$ open/write FIL_TMP 'T_ASCIZ_TMP'
$ TAB[0,8]=9
$LOOP_ITMLST:
$ read /END_OF_FILE=VMSDEF_EOF FIL_INP T_RECORD
$ if _D then $ show symbol T_RECORD
$ if (F$EDIT(T_RECORD,"COLLAPSE") .eqs. "")
$ then
$   goto LOOP_ITMLST				! skip empty line
$ endif
$ if (F$EXTRACT(0,1,T_RECORD) .eqs. "=")
$ then
$   if (F$EXTRACT(0,7,T_RECORD) .eqs. "=TITLE=")
$   then
$     T_TITLE = F$EXTRACT(7,9999,T_RECORD)
$     T_TITLE = F$ELEMENT(0," ",T_TITLE)
$     T_TITLE = F$ELEMENT(0,TAB,T_TITLE)
$     T_TITLE = T_TITLE - "VMSDEF_"
$     write FIL_OUT TAB,".address VMSDEF_GR_", T_TITLE		! ar_itmtbl
$     write FIL_OUT TAB,".address VMSDEF_GR_CB_", T_TITLE	! ar_conmsktbl
$     write FIL_TMP "VMSDEF_T_DIRECTORY__''L_ADDRESS_COUNT':''TAB'.asciz '",T_TITLE ,"'"
$     write FIL_OUT TAB,".address VMSDEF_T_DIRECTORY__''L_ADDRESS_COUNT'" ! at_vmsdefnam
$     L_ADDRESS_COUNT = L_ADDRESS_COUNT + 1
$     X_TITLE = "TRUE"
$   endif
$ endif
$ if (X_TITLE)				! TRUE = title found, next file
$ then
$   goto FOUND_TITLE
$ endif
$!
$VMSDEF_EOF:
$ write SYS$ERROR "%VMSDEF_BLDDIR2MAR-W-NOTITLE, =TITLE= entry not in file!
$ write SYS$ERROR " \item=", T_FIL_INP, "\"
$!
$FOUND_TITLE:
$ close FIL_INP
$ goto LOOP_VMSDEF		! next file
$!
$NO_MORE_VMSDEF:
$!+
$! terminate list
$!-
$ write FIL_OUT ";"
$ write FIL_OUT TAB,".long",TAB,"0 ; terminate list"
$ write FIL_OUT TAB,".long",TAB,"0"
$ write FIL_OUT TAB,".long",TAB,"0"
$ write FIL_OUT ";"
$!
$ close/nolog FIL_INP
$ close/nolog FIL_OUT
$ close/nolog FIL_TMP
$!
$ append 'T_ASCIZ_TMP' 'T_FIL_OUT'
$ delete 'T_ASCIZ_TMP';*
$!
$ open/append FIL_OUT 'T_FIL_OUT'
$ write FIL_OUT ";"
$ write FIL_OUT TAB,".end"
$ close/nolog FIL_OUT
$!
$ exit
$! ----------------------------------------------------------------------------
